# Genome Alignment and Genomic Variant Identification Pipeline

This pipeline performs alignment of multiple samples of different individuals to a common reference genome, followed by the identification of genomic variants. The pipeline consists of 4 stages that are executed sequentially on the cluster.

1. **prepare-genome:** Prepare reference genome for analysis: create index, dictionary, etc.
2. **genome-alignment:** From a list of fastq files, bam files are generated.
3. **merge-bams:** If multiple bam files exist for the same sample, they are merged in this phase.
4. **genomic-variant-call:** Genomic variants are identified.

## Prepare Genome

In this stage de reference genome is prepared by running the following commands:

   - bwa index: which generates the files AMB, ANN, BWT, PAC, and SA
   - samtools faidx: which generates the FAI file
   - samtools dict: which generates the DICT file

Once completed the **./ref_genome/** folder should contain the following files related to the reference genome:

  - &lt;genome&gt;.dict
  - &lt;genome&gt;.fa 
  - &lt;genome&gt;.fa.amb
  - &lt;genome&gt;.fa.ann
  - &lt;genome&gt;.fa.bwt
  - &lt;genome&gt;.fa.fai
  - &lt;genome&gt;.fa.pac
  - &lt;genome&gt;.fa.sa
  
[Read more](https://gitlab.com/ebd-bcb/genome-alignment-using-bwa).

## Genome Alignment

In this stage, a table in CSV format is generated containing the sample names and identifiers of the corresponding fastq files. This file is used during the execution of the genomic-alignment.yaml job to divide the task and execute it in parallel. Each pod of the job will take one line from the CSV file to perform its part of the work. The output of this job will be dumped into the bams/ folder.

[Read more](https://gitlab.com/ebd-bcb/genome-alignment-using-bwa)

## Merge BAMs

If there are multiple BAM files for the same sample of an individual, they will be merged into one, resulting in a single BAM file for that sample in the bams/ folder.

## Genomic Variant Call

In this final phase, genetic variations or variations in the genome of an individual are identified and characterized. To achieve this, the task is divided into smaller tasks that are executed in parallel on the cluster. For this purpose, an input file containing a table in bed format with the regions to be analyzed is used. Each pod of the job will take one line from this file and save it as an independent bed file, which will be stored in the beds/ folder with the name of the pod that executes it. The output of this phase is .g.vcf files saved in the gvcfs/ folder.

[Read more](https://gitlab.com/ebd-bcb/genomic-variant-call)

# Pipeline

To execute the pipeline, it is necessary to edit the 3 yaml files, providing the necessary data for their correct execution. To facilitate the configuration of these yaml files, you can use the **configure.sh** script which will also generate the aforementioned CSV files, which are necessary for job execution.

## Configure

First, **Edit configure.sh** file and asign the desired values to the variables.

Job specific variables:

- **user_name:** kubernetes service account.
- **parallelism_alignment:** number of pods to be run in parallel during alignment process (might be overwritten).
- **parallelism_merge:** number of pods to be run in parallel while mergin bam files (might be overwritten).
- **parallelism_variant:** nubmer of pods to be run in parallel while finding genomic variants (might be overwritten).
- **nfs_server:** ip address o the nfs server.
- **nfs_path:** the path of the data folder.

General variables:

- **filename_pattern:** the common pattern of all fastq files that will be processed 
- **individual_prefix:** sample names will start with this prefix
- **output_file_samples:** name of the file to store the sample table															
- **output_bed_file_mapping:** name of the file to store the beds table

Second, execute:

```
./configure.sh
```

Three new YAML files will have been generated, the names of the files will start with the name of the user's service account.

  - &lt;username&gt;_genome_alignment.yaml
  - &lt;username&gt;_merge-bams.yaml
  - &lt;username&gt;_genomic-variant-call.yaml
  
## Data

Please note that before launching the jobs, the same folder structure contained in the **data/** folder of this repository must be created on the server's NFS path.

The .csv files generated by the configure.sh script should be placed in the root **./** directory.

The **./ref_genome/** folder should contain the reference genome **.fa** file:

  - &lt;genome&gt;.fa 

And the **fastqs** files with the different samples should be placed in the **./fastqs/** directory.

Additionally, ensure that all files have the necessary permissions to be accessible from the containers that will run in the job pods (consult with the administrator for more details).

## Launching the Jobs

The three jobs must be launched sequentially in the same order as shown below.

**It is very important not to launch a job until the preceding one has finished** because the input files for the next job are the output files of the previous job.

Launch first stage:

```
kubectl apply -f <username>_prepare-genome.yaml
```

Launch second stage job:

```
kubectl apply -f <username>_genome-alignment.yaml
```

Launch third stage job:

```
kubectl apply -f <username>_merge-bams.yaml
```

Launch fourth stage job:

```
kubectl apply -f <username>_genomic-variant-call.yaml
```

## Automating Pipeline Execution

It is also possible to launch the jobs with the help of the **run_jobs.sh** script to which the names of the three yaml files will be passed as parameters:


```
./run_jobs.sh <username>_prepare-genome.yaml <username>_genome-alignment.yaml <username>_merge-bams.yaml <username>_genomic-variant-call.yaml
```


The script will launch the first job and will not launch the next job until the current job has finished. While waiting to launch another job, every 10 seconds it displays the elapsed time since its execution began.

If the script is interrupted, the job currently running will not stop. The script can be run again with the three yaml file names as parameters without problems because it will detect that the job in question is running and will continue to wait for it to finish. When a job has finished, it displays the total execution time regardless of whether time has passed since it finished its execution.
